print("IMPORTING CALIBRATE MODE")

from mpython import *
import printer_core as core
import printer_gui as gui
import printer_global_variable as glovar
import printer_stepper as stepper
import printer_input as inpt

print_str_0 = "1010101010101010"
print_str_1 = "0101010101010101"
print_flag = True
current_str = ""
next_str = ""


def enter_calibrate_mode():
    global current_str, next_str, print_flag
    oled.fill(0)
    gui.auto_show_text(1, "校 准 模 式")
    core.init_hardware_data()
    while True:
        print_flag = not print_flag
        if print_flag:
            current_str = print_str_0
            next_str = print_str_1
        else:
            current_str = print_str_1
            next_str = print_str_0
        time.sleep_ms(glovar.ARM_DEAD_ZONE_DELAY)
        core.servo.write_angle(glovar.arm_steps_angel[glovar.current_arm_at_step])
        time.sleep_ms(glovar.ARM_DEAD_ZONE_RESET_DELAY)
        core.print_col(current_str)
        core.prepare_col(next_str)
        stepper.steps(glovar.STEPPER_STEPS)
        if inpt.is_pressed(inpt.a):
            return
