"""
本作品采用知识共享署名-非商业性使用-相同方式共享 4.0 国际许可协议进行许可。
当您使用本作品相关图纸或源码等资料时，视为您同意并遵循此协议内容。

项目开源地址：https://www.laserblock.cn/thread-23573-1-1.html

作者：李嘉泳
邮箱：17620745509@126.COM
BiliBili：https://space.bilibili.com/106497171

Laserblock开源社区：https://www.laserblock.cn/
"""
print("IMPORTING DOT_SERVO")
# mPythonType:0
from mpython import *

import config as cfg

from servo import Servo
import printer_global_variable as glovar

UP_ANGEL = cfg.cfg["core"]["dot_servo"]["up_angel"]
DOWN_ANGEL = cfg.cfg["core"]["dot_servo"]["down_angel"]
ANGEL_FIX = cfg.cfg["core"]["dot_servo"]["angel_fix"]
UP_DELAY = cfg.cfg["core"]["dot_servo"]["up_delay"]
DOWN_DELAY = cfg.cfg["core"]["dot_servo"]["down_delay"]
STANDBY_ANGEL = cfg.cfg["core"]["dot_servo"]["standby_angel"]
STANDBY_DELAY = cfg.cfg["core"]["dot_servo"]["standby_delay"]

steps = 0  # Angel per steps

servo = Servo(0, min_us=500, max_us=2500, actuation_range=180)
servo.write_angle(STANDBY_ANGEL)


def set_dot(dot):
    if dot:
        servo.write_angle(round(UP_ANGEL + (steps * glovar.current_print_progress_row)))
        time.sleep_ms(UP_DELAY)
    else:
        servo.write_angle(DOWN_ANGEL)
        time.sleep_ms(DOWN_DELAY)


def dot_once():
    set_dot(True)
    set_dot(False)


def dot_standby():
    servo.write_angle(STANDBY_ANGEL)
    time.sleep_ms(STANDBY_DELAY)
