"""
本作品采用知识共享署名-非商业性使用-相同方式共享 4.0 国际许可协议进行许可。
当您使用本作品相关图纸或源码等资料时，视为您同意并遵循此协议内容。

项目开源地址：https://www.laserblock.cn/thread-23573-1-1.html

作者：李嘉泳
邮箱：17620745509@126.COM
BiliBili：https://space.bilibili.com/106497171

Laserblock开源社区：https://www.laserblock.cn/
"""
print("IMPORTING GUI")
# mPythonType:0
from mpython import *
import os
import printer_global_variable as glovar
import printer_file_system as file
import printer_core as core
import printer_gui_menu as menu
import math
import printer_input as inpt
import printer_screen_saver as saver


def get_screen_axis_x(number):
    if number < 0:
        return 128
    return number * 12


def get_screen_axis_y(number):
    if number < 0:
        return 128
    return number * 16


def smart_get_screen_axis(this_str):
    str_len = 0
    this_str = str(this_str)
    for this_char in this_str:
        if this_char == " " or this_char == ".":
            str_len += 4
            continue
        if this_char.isalpha() or this_char.isdigit():
            str_len += 8
        else:
            str_len += 12
    return str_len


def screen_fresh_percent(percent):
    percent = round(percent)
    if glovar.gui_current_displaying_percent == percent:
        return
    if percent == 100:
        glovar.gui_current_displaying_percent = -1
    else:
        glovar.gui_current_displaying_percent = percent
    progress_bar_two_side_interval = 24
    glovar.myUI.ProgressBar(
        progress_bar_two_side_interval,
        32,
        128 - 4 - (progress_bar_two_side_interval * 2),
        8,
        percent,
    )
    oled.show()
    saver.reset()


def screen_clear_line(line):
    oled.fill_rect(0, gui.get_screen_axis_y(line), 128, 16, 0)


def auto_show_text(line, str):
    text_two_side_interval = round(smart_get_screen_axis(str) / 2)
    oled.DispChar(str, (64 - text_two_side_interval), get_screen_axis_y(line), 1)
    oled.show()
    saver.reset()


def key_array_state(key_array):
    for i in key_array:
        if inpt.is_pressed(i):
            return True
    return False


def view_hex_file(file_path, key_array):
    glovar.hex_data_size = os.stat(file_path)[6]
    glovar.hex_data_width = int(((glovar.hex_data_size * 8) / glovar.hex_data_height))
    # oled.fill(0)#---GUI---
    f = open(file_path, "rb")
    all_byte = f.read()
    f.close()
    if glovar.hex_data_size > 256:
        loop_display_range = -1 * (glovar.hex_data_width - 128)
        while not key_array_state(key_array):
            for i in range(0, loop_display_range, -1):
                oled.Bitmap(
                    i,
                    32,
                    bytearray(all_byte),
                    glovar.hex_data_width,
                    glovar.hex_data_height,
                    1,
                )
                oled.show()
                if key_array_state(key_array):
                    return
            for i in range(loop_display_range, 0, 1):
                oled.Bitmap(
                    i,
                    32,
                    bytearray(all_byte),
                    glovar.hex_data_width,
                    glovar.hex_data_height,
                    1,
                )
                oled.show()
                if key_array_state(key_array):
                    return
    else:
        oled.Bitmap(
            0, 32, bytearray(all_byte), glovar.hex_data_width, glovar.hex_data_height, 1
        )
        oled.show()
        while not key_array_state(key_array):
            time.sleep_ms(50)


def print_content_confirm(file_path):
    oled.fill(0)
    auto_show_text(0, "开始打印？")
    view_hex_file(file_path, [inpt.b, inpt.a])
    if inpt.is_pressed(inpt.a):
        return True
    if inpt.is_pressed(inpt.a):
        return False


def convert_time(input_seconds):
    hour = 0
    minute = 0
    second = 0
    hour = math.floor(input_seconds / 3600)
    input_seconds = input_seconds - hour * 3600
    minute = math.floor(input_seconds / 60)
    input_seconds = input_seconds - minute * 60
    second = input_seconds
    return [hour, minute, second]
